#region using

using System;
using System.Web;
using System.Web.UI;
using BlogEngine.Core.Web.Controls;
using BlogEngine.Core;
using System.Text.RegularExpressions;
using System.Collections.Generic;
using System.Net;

#endregion

/// <summary>
/// Transliterate post Chinese slug into English
/// </summary>
[Extension("ʹ Google Api Զ벢תΪӢı", "1.0", "<a href=\"http://www.blogyi.net\">BlogYi.NET</a>")]
public class GoogleSlugTransliterator
{
    /// <summary>
    /// Hooks up an event handler to the Post.Serving event.
    /// </summary>
    static GoogleSlugTransliterator()
    {
        Post.Saving += new EventHandler<SavedEventArgs>(Post_Saving);
    }

    /// <summary>
    /// Handles the Post.Saving event.
    /// </summary>
    private static void Post_Saving(object sender, SavedEventArgs e)
    {
        Post post = (Post)sender;
        if (post.IsNew)
        {
            try
            {
                WebClient wb = new WebClient();
                string url = "http://ajax.googleapis.com/ajax/services/language/translate?v=1.0&langpair=zh%7Cen&q={0}";
                string jsonText = wb.DownloadString(string.Format(url, HttpUtility.UrlEncode(post.Title)));

                //sample: {"responseData": {"translatedText":"text"}, "responseDetails": null, "responseStatus": 200};
                string responseStatus = jsonText.Substring(jsonText.IndexOf("\"responseStatus\":"), jsonText.Length - 1 - jsonText.IndexOf("\"responseStatus\":")).Trim();
                string translatedText = jsonText.Substring(jsonText.IndexOf("\"translatedText\":\""), jsonText.IndexOf("}, \"responseDetails\"") - jsonText.IndexOf("\"translatedText\":\"")).Trim();
                translatedText = translatedText.Replace("\"translatedText\":\"", string.Empty).Replace("\"", string.Empty);
                responseStatus = responseStatus.Replace("\"responseStatus\":", string.Empty).Trim();
                if (responseStatus == "200")
                {
                    string slug = Utils.RemoveIllegalCharacters(translatedText);
                    if (slug.Length > 30)
                        slug.Substring(0, 30);

                    post.Slug = Utils.RemoveIllegalCharacters(translatedText).ToLower();
                }
            }
            catch
            {
                // We maybe need to catch some exception
            }
        }
    }
}